//SleepFix - 2012, frostegater
//credits: SilverSpring, Torch, Namana

#include <pspsdk.h>
#include <pspkernel.h>
#include <stdio.h>
#include <pspsysevent.h>
#include <psppower.h>
#include <kubridge.h>
#include "sysconhk.h"

PSP_MODULE_INFO("SleepFix", 0x1000, 1, 0);
PSP_MAIN_THREAD_ATTR(0);

int keyconfig;
PspSysEventHandler events;

int rec_thread(SceSize args, void *argp)
{
	sceKernelDelayThread(1000 * 1000);
	scePowerSetClockFrequency(222, 222, 111);

	sceKernelExitDeleteThread(0);

	return 0;
}

int suspend_handler(int ev_id, char *ev_name, void *param, int *result)
{
	if(keyconfig == PSP_INIT_KEYCONFIG_GAME)
		scePowerSetClockFrequency(133, 133, 66);
	else
		scePowerSetClockFrequency(20, 20, 10);

	SceUID rec_th = sceKernelCreateThread("rec_th", rec_thread, 0x12, 0x500, 0, NULL);
	if(rec_th >= 0)
		sceKernelStartThread(rec_th, 0, NULL);

	return 0;
}

int main_thread(SceSize args, void *argp)
{
	events.size = 0x40;
	events.name = "SuspendEvent";
	events.type_mask = 0x0000FF00;
	events.handler = suspend_handler;

	sceKernelRegisterSysEventHandler(&events);

	return 0;
}

int module_start(SceSize args, void *argp)
{
	keyconfig = kuKernelInitKeyConfig();
	SceUID th = sceKernelCreateThread("main_thread", main_thread, 0x12, 0x500, 0, NULL);
	if(th >= 0)
		sceKernelStartThread(th, args, argp);

	return 0;
}

int module_stop(SceSize args, void *argp)
{
	uninstall_syscon_hook();

	return 0;
}
